<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>
	
<style>

</style>
	
<script language="JavaScript">
var debug = false;
var currentStep = 1;
var lysatesIsValid = false;

function init()
{
	var frm = document.forms['reggie'];
	var lysates = getUnprocessedLysates();
	
	var lysateList = frm.lysates;
	if (lysates != null && lysates.length > 0)
	{
		for (var i=0; i < lysates.length; i++)
		{
			var lysate = lysates[i];
			var name = (i+1) + ': ' + lysate.name;
			if (lysate.bioWell)
			{
				name += ' -- ' + lysate.bioWell.bioPlate.name + ' (' + lysate.bioWell.location+')';
			}
			var selected = i < 12;
			var option = new Option(name, lysate.id, selected, selected);
			option.lysate = lysate;
			lysateList.options[lysateList.length] = option;
		}
		lysatesOnChange();
	}
	else
	{	
		setInputStatus('lysate', 'No Lysate available for processing.', 'invalid');
	}
	Main.show('gonext');
}

function getUnprocessedLysates()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading Lysate extracts...');
		var url = 'Extraction.servlet?ID=<%=ID%>&cmd=GetUnprocessedLysates';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.lysates;
}

function step1IsValid()
{
	return lysatesIsValid;
}

function goCreate()
{
	if (!step1IsValid()) return;
	var frm = document.forms['reggie'];
	frm.submit();
}

function lysatesOnChange()
{
	lysatesIsValid = false;
	
	var frm = document.forms['reggie'];
	var lysateList = frm.lysates;
	
	var numSelected = 0;
	for (var i = 0; i < lysateList.length; i++)
	{
		if (lysateList[i].selected) numSelected++;
	}
	
	if (numSelected != 12)
	{
		setInputStatus('lysate', 'Must select 12 items.', 'invalid');
		return;
	}
	
	lysatesIsValid = true;
	setInputStatus('lysate', '', 'valid');

}

</script>


</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="index.jsp?ID="+ID%>" 
		/><p:pathelement title="Lab Tracking Protocol for Allprep isolation" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>	

	<form name="reggie" onsubmit="return false;" action="allprep_protocol2.jsp?ID=<%=ID%>" method="post" target="_new">
	
	<!-- 1. Case name-->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select unprocessed lysate items</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">Lysate</td>
				<td class="input" rowspan="2">
					<select style="width:90%" name="lysates" id="lysates" multiple="multiple" size="15" onchange="lysatesOnChange()"></select>
				</td>
				<td class="status" id="lysate.status" rowspan="2"></td>
				<td class="help" rowspan="2"><span id="lysate.message" class="message" style="display: none;"></span>
					Select 12 items. The list contain Lysate items that has not yet been processed
					(determined by absence of a 'creation' date).
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
		
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocreate" title="Finish" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" /></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>