<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">
var debug = false;
var currentStep = 1;
var moveDateIsValid = false;

function init()
{
	var frm = document.forms['reggie'];

	var plates = getParaffinBlocks();
	
	var plateList = frm.plates;
	if (plates != null && plates.length > 0)
	{
		for (var i=0; i < plates.length; i++)
		{
			var plate = plates[i];
			var option = new Option(plate.name, plate.id);
			option.plate = plate;
			plateList.options[plateList.length] = option;
		}
	}
	else
	{	
		setInputStatus('plates','No paraffin blocks could be found.', 'invalid')
	}
	Main.show('gonext');
}

function getParaffinBlocks()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading paraffin blocks...');
		var url = 'Histology.servlet?ID=<%=ID%>&cmd=GetParaffinBlocks';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.plates;
}

function selectParaffinBlocks()
{
	var frm = document.forms['reggie'];
	if (frm.plates.disabled) return;
	
	var url = getRoot() + 'biomaterials/bioplates/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=setParaffinBlockCallback';
	url += '&filter:STRING:bioPlateType.name=Paraffin+block';
	Main.openPopup(url, 'SelectParaffinBlocks', 1050, 700);
}

function setParaffinBlockCallback(id, name)
{
	var frm = document.forms['reggie'];
	var plates = frm.plates;
	for (var i = 0; i < plates.length; i++)
	{
		if (plates[i].value == id)
		{
			plates[i].selected = true;
			return;
		}
	}

	var option = new Option(name, id, true, true);
	plates[plates.length] = option;
}


function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	Main.hide('navigation');
	if (currentStep == 1)
	{		
		gotoStep2();
	}
	else if (currentStep == 2)
	{
		gotoStep3();
	}
	Main.show('navigation');
}

function step1IsValid()
{
	var frm = document.forms['reggie'];
	var plates = frm.plates;
	var selectedPlates = new Array();
	for (var i=0; i < plates.length; i++)
	{
		if (plates[i].selected)
		{
			selectedPlates[selectedPlates.length] = plates[i].value;
		}
	}
	
	if (selectedPlates.length == 0)
	{
		setInputStatus('plates', 'Not selected', 'invalid');
		return false;
	}
	
	setInputStatus('plates', '', 'valid');

	return true;
}

function gotoStep2()
{
	if (!step1IsValid()) return;
	
	var frm = document.forms['reggie'];
	
	frm.submit();
}


</script>


</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="index.jsp?ID="+ID%>" 
		/><p:pathelement title="Create lab tracking protocol for FFPE" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;" action="histology_protocol2.jsp?ID=<%=ID%>" method="post" target="_new">
	
	<!-- 1. Case name-->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select paraffin blocks</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">Paraffin blocks</td>
				<td class="input"><select style="width:90%" name="plates" id="plates" multiple="multiple" size="18"></select>
				
					<base:buttongroup style="margin-top: 0.5em;">
						<base:button title="Select manually&hellip;" onclick="selectParaffinBlocks()" id="btnSelectParaffinBlocks" />
					</base:buttongroup>
				</td>
				<td class="status" id="plates.status"></td>
				<td class="help"><span id="plates.message" class="message" style="display: none;"></span>
					The list contain all paraffin blocks with no child HEglass plates.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation" id="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)" style="display: none;"/></td>
			<td><base:button id="gocreate" title="Create" image="<%=home+"/images/gonext.png"%>" onclick="goCreate()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>